using System.Linq.Expressions;
using System.Reflection;

namespace Luticate2.Auth.Utils.Interfaces
{
    public interface ILuObjectConverterDescriptorOptions
    {
        ILuConvertersTypeConverter TypeConverter { get; }
    }

    public interface ILuObjectConverterDescriptor
    {
        LambdaExpression GetMemberValueExpression(MemberInfo memberInfo, ILuObjectConverterDescriptorOptions options);

        LambdaExpression GetMethodValueExpression(MethodInfo methodInfo, ILuObjectConverterDescriptorOptions options);
    }

    public interface ILuObjectConverterDescriptor<TTypeFrom, TTypeTo> : ILuObjectConverterDescriptor
    {
    }

    public interface ILuObjectConverterDescriptorIdentity : ILuObjectConverterDescriptor
    {
    }
}